<?xml version="1.0" encoding="UTF-8"?>
<!-- created with XMLSpear -->
<!-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
<!-- version 1.2  2012-09-26  by DD-->
<!-- Check if URL already has query parameters attached. In this case concatenate with ampersand -->
<!-- made global variables for proxy and timeout settings -->
<!-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
<!-- version 1.1  2012-09-18  by DD-->
<!-- Post calls can have queryStringParameters and FormPostHttpBody : both were written to the parms element -->
<!-- The java software could no longer distinguish them -->
<!-- Query string parameters are no longer written to the parms element but are concatenated in the URL -->
<!-- You could als make the choice to to rhis just for post requests but now it is done for all requests -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:import href="base64decoder.xslt"/>
	<xsl:output method="xml" indent="yes" omit-xml-declaration="no"/>
	<!-- give a short description of this configuration file-->
	<xsl:variable name="v_config_description">your description</xsl:variable>
	<!-- give a short name for this configuration-->
	<!-- This name will be listed in the  JCC selectlist to choose your configuartion-->
	<xsl:variable name="v_config_environment">your_environment_or_name</xsl:variable>
	<!-- give a unique name for this check-->
	<xsl:variable name="v_check_id">check_id</xsl:variable>
	<!-- give a short description for this check-->
	<xsl:variable name="v_check_name">check name</xsl:variable>
	<xsl:variable name="v_useproxy">false</xsl:variable>
	<xsl:variable name="v_timeout">300000</xsl:variable>
	<xsl:variable name="v_status"></xsl:variable>
	<!--copy all  attributes and nodes, special cases are cathed by special templates-->
	<xsl:template match="/">
		<configuration color="green" description="{$v_config_description}"
			environment="{$v_config_environment}" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
			xsi:noNamespaceSchemaLocation="../xsd/jcc.xsd">
			<statistics>
				<outdir>H:\My Documents\JCheckCenter\Statistics\Example</outdir>
				<datePattern>_yyyy-MM-dd</datePattern>
			</statistics>
			<checkList>
				<checker className="com.donkeydevelopment.checkcenter.check.httpsession.HTTPSessionChecker">
					<check className="com.donkeydevelopment.checkcenter.check.httpsession.HTTPSessionCheck">
						<id>
							<xsl:value-of select="$v_check_id"/>
						</id>
						<name><xsl:value-of select="$v_check_name"/></name>
						<selected>true</selected>
						<data>
							<httpSessionCheck>
								<session trustAll="true" verifyHostname="false" ignoreErrors="false">
									<xsl:if test="$v_useproxy='true'">
										<proxy>
											<host>127.0.0.1</host>
											<user>${CORPORATE_KEY}</user>
											<password>${CORPORATE_KEY_PW}</password>
											<port>8888</port>
										</proxy>
									</xsl:if>
									<xsl:apply-templates select="/TestCase/Items/Request"/>
								</session>
							</httpSessionCheck>
						</data>
					</check>
				</checker>
			</checkList>
		</configuration>
	</xsl:template>
	<!-- template for request -->
	<xsl:template match="Request">
		<xsl:variable name="previouscount" select="count(preceding-sibling::Request) + 1"/>
		<xsl:element name="request">
			<!-- use auto direct true if you did remove the requests which were driven -->
			<!--  by a 302 redirect response -->
			<xsl:attribute name="autoredirect">true</xsl:attribute>
			<xsl:attribute name="method">
				<xsl:value-of select="@Method"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="$previouscount"/>
			</xsl:attribute>
			<description>description of <xsl:value-of select="$previouscount"/>
			</description>
			<xsl:variable name="v_queryparm">
				<xsl:apply-templates select="QueryStringParameters"/>
			</xsl:variable>
			<xsl:variable name="urlcon">
				<xsl:choose>
					<xsl:when test="string-length($v_queryparm) > 0">
						<xsl:choose>
							<xsl:when test="contains(@Url, '?')">
								<xsl:value-of select="concat(@Url,'&amp;',$v_queryparm)"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="concat(@Url,'?',$v_queryparm)"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<!-- no query pararameters to concatenate -->
						<xsl:value-of select="@Url"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<url>
				<xsl:value-of select="$urlcon"/>
			</url>
			<timeout>
				<xsl:value-of select="$v_timeout"/>
			</timeout>
			<xsl:apply-templates select="Headers"/>
			<xsl:apply-templates select="FormPostHttpBody"/>
			<xsl:apply-templates select="StringHttpBody"/>
			<!-- have not seen this yet -->
			<xsl:apply-templates select="BinaryHttpBody"/>
			<response>
				<status><xsl:value-of select="$v_status"/></status>
				<checkPattern/>
				<showPattern/>
			</response>
		</xsl:element>
	</xsl:template>
	<!-- template for headers -->
	<xsl:template match="Headers">
		<headers>
			<xsl:apply-templates select="Header"/>
		</headers>
	</xsl:template>
	<xsl:template match="Header">
		<namevalue>
			<name>
				<xsl:value-of select="@Name"/>
			</name>
			<value>
				<xsl:value-of select="@Value"/>
			</value>
		</namevalue>
	</xsl:template>
	<!-- template for QueryStringParameters -->
	<xsl:template match="QueryStringParameters">
		<xsl:for-each select="QueryStringParameter">
			<xsl:choose>
				<xsl:when test="position()>1">&amp;</xsl:when>
				<xsl:otherwise></xsl:otherwise>
			</xsl:choose>
			<xsl:value-of select="encode-for-uri(@Name)"/>=<xsl:value-of select="encode-for-uri(@Value)"/>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="FormPostHttpBody">
		<parms>
			<xsl:apply-templates select="FormPostParameter"/>
		</parms>
	</xsl:template>
	<!-- template for FormPostParameter -->
	<xsl:template match="FormPostParameter">
		<namevalue>
			<name>
				<xsl:value-of select="@Name"/>
			</name>
			<value>
				<xsl:value-of select="@Value"/>
			</value>
		</namevalue>
	</xsl:template>
	<!-- mimetype in checker is hardcoded set to text/plain -->
	<!-- charset in checker is hardcoded set to UTF-8 -->
	<xsl:template match="StringHttpBody">
		<stringBody>
			<!-- Fiddler webtest has encoded the body in BASE64-->
			<!-- xslt engine will automaticaly escape resreved XML chareacters. -->
			<!-- so no need to use a CDATA section for the decoded content -->
			<xsl:call-template name="convertBase64ToAscii">
				<xsl:with-param name="base64String">
					<xsl:value-of select="."/>
				</xsl:with-param>
			</xsl:call-template>
		</stringBody>
	</xsl:template>
	<!-- have not seen this yet -->
	<!-- checker expects the content to be   BASE64 encoded -->
	<!-- and it will be decoded by the checker -->
	<xsl:template match="BinaryHttpBody">
		<binaryBody>
			<xsl:value-of select="."/>
		</binaryBody>
	</xsl:template>
</xsl:stylesheet>
